---------------- UNION
-- 0 Conception des requtes
--> Requte 1: je souhaite afficher les numros et noms des revendeurs de la table revendeur
--> Requte 2: je souhaite afficher les numros et noms des revendeurs de la table revendeur
-- except pour les revendeurs ayant les numros suivants 547, 192

-- 1 je souhaite rcuprer toutes les lignes des deux requtes sans doublons
-- rsultat : 701
-- 2 je souhaite rcuprer toutes les lignes des deux requtes mais avec des doublons (si dans l'une et dans l'autre)
-- En affichant une colonne en plus qui m'indique l'origine de la ligne (requte 1 ou 2) 
-- et je tri la seconde requte (tout  la fin) sur le resellerkey
-- rsultat : 1400
-- 3 Je souhaite rcuprer uniquement les lignes qui sont dans les deux tables (si une valeur n'est pas dans la seconde, je ne la garde pas : intersection)
-- rsultat : 699
-- 4 Je souhaite rcuprer les lignes de la premire requte qui ne sont pas dans la seconde
-- rsultat : 2

-- 1. 701 car doublons supprims (si dans l'une et dans l'autre)
-- 701
SELECT ResellerKey, ResellerName 
FROM DimReseller 
UNION  
-- 699
SELECT ResellerKey, ResellerName 
FROM DimReseller 
WHERE ResellerKey NOT IN (547, 192)  

-- 2. UNION ALL
-- 1400 car il a gard les doublons (dans l'une et l'autre)
-- donc 699 en commun * 2 + les 2 en+ que dans la seconde requte
SELECT ResellerKey, ResellerName, 'req1' as origine
FROM DimReseller 
UNION  all
SELECT ResellerKey, ResellerName, 'req2' as origine
FROM DimReseller 
WHERE ResellerKey NOT IN (547, 192)
order by resellerkey

-- 3. intersect
-- 699 : il ne prend que les lignes en commun (sans doublons)
SELECT ResellerKey, ResellerName 
FROM DimReseller 
intersect 
SELECT ResellerKey, ResellerName 
FROM DimReseller 
WHERE ResellerKey NOT IN (547, 192)

-- 4. except
-- 2 : il ne prend que les lignes de la premire requte qui ne sont
-- pas dans la seconde requte
SELECT ResellerKey, ResellerName 
FROM DimReseller 
Except 
SELECT ResellerKey, ResellerName 
FROM DimReseller 
WHERE ResellerKey NOT IN (547, 192)

-- 5 Refaire la requte ci-dessous mais en utilisant UNION
-- Je souhaite afficher les lignes clients correspondant  ce profil :
-- ceux qui ont seulement le niveau bac (valeur "baccalaurat")(frencheducation) et qui sont  5-10 miles du travail (commutedistance)
-- Dans une seconde requte, Je souhaite afficher les lignes clients correspondant  ce profil :
-- ainsi que ceux qui sont bac + 4 et qui sont  1-2 miles
-- Puis concatner les lignes des deux requtes !
-- Contrler les temps d'execution
-- Rsultat : 1706

-- Where : 12 + 183
select *
From dimcustomer
where (FrenchEducation = 'Baccalaurat' and CommuteDistance = '5-10 Miles')
 or (FrenchEducation = 'Bac + 4' and CommuteDistance = '1-2 Miles')

set statistics time on
Dbcc freeproccache

-- Avec UNION : 16 + 185
select * -- 1155
From dimcustomer
where FrenchEducation = 'Baccalaurat' and CommuteDistance = '5-10 Miles'
	UNION
select * -- 551
From dimcustomer
where FrenchEducation = 'Bac + 4' and CommuteDistance = '1-2 Miles'